Index: trunk/src/VBox/GuestHost/DisplayServerType.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DisplayServerType.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DisplayServerType.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2023 Oracle and/or its affiliates.
+ * Copyright (C) 2023-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDDroppedFiles.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDDroppedFiles.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDDroppedFiles.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDMIME.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDMIME.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDMIME.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDPath.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDPath.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDPath.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDTransferList.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDTransferList.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDTransferList.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDTransferObject.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDTransferObject.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDTransferObject.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/DnDUtils.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/DnDUtils.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/DnDUtils.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2022-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2022-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2014-2023 Oracle and/or its affiliates.
+# Copyright (C) 2014-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/testcase/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/testcase/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2020-2023 Oracle and/or its affiliates.
+# Copyright (C) 2020-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDPath.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDPath.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDPath.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2020-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2020-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDTransferList.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDTransferList.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDTransferList.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2020-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2020-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDTransferObject.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDTransferObject.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDnDTransferObject.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2020-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2020-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDragAndDropQt/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDragAndDropQt/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDragAndDropQt/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2022-2023 Oracle and/or its affiliates.
+# Copyright (C) 2022-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDragAndDropQt/tstDragAndDropQt.cpp
===================================================================
--- trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDragAndDropQt/tstDragAndDropQt.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/DragAndDrop/testcase/tstDragAndDropQt/tstDragAndDropQt.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2022-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2022-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/HGSMI/.scm-settings
===================================================================
--- trunk/src/VBox/GuestHost/HGSMI/.scm-settings	(revision 104792)
+++ trunk/src/VBox/GuestHost/HGSMI/.scm-settings	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2010-2023 Oracle and/or its affiliates.
+# Copyright (C) 2010-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/HGSMI/HGSMICommon.cpp
===================================================================
--- trunk/src/VBox/GuestHost/HGSMI/HGSMICommon.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/HGSMI/HGSMICommon.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2024 Oracle and/or its affiliates.
  *
  * Permission is hereby granted, free of charge, to any person
Index: trunk/src/VBox/GuestHost/HGSMI/HGSMIMemAlloc.cpp
===================================================================
--- trunk/src/VBox/GuestHost/HGSMI/HGSMIMemAlloc.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/HGSMI/HGSMIMemAlloc.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2014-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2014-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/HGSMI/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/HGSMI/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/HGSMI/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2006-2023 Oracle and/or its affiliates.
+# Copyright (C) 2006-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2008-2023 Oracle and/or its affiliates.
+# Copyright (C) 2008-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardDataObjectImpl-win.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardDataObjectImpl-win.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardDataObjectImpl-win.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2019-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardEnumFormatEtcImpl-win.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardEnumFormatEtcImpl-win.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardEnumFormatEtcImpl-win.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2013-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2013-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardMIME.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardMIME.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardMIME.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2019-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardPath.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardPath.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardPath.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2019-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/ClipboardStreamImpl-win.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/ClipboardStreamImpl-win.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/ClipboardStreamImpl-win.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2019-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2020-2023 Oracle and/or its affiliates.
+# Copyright (C) 2020-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-common.cpp	(revision 106061)
@@ -7,5 +7,5 @@
  * Includes contributions from François Revol
  *
- * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers-http.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers-http.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers-http.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2020-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2020-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers-provider-local.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers-provider-local.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers-provider-local.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2023 Oracle and/or its affiliates.
+ * Copyright (C) 2023-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-transfers.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2019-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2019-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-win.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-win.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-win.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/clipboard-x11.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/clipboard-x11.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/clipboard-x11.cpp	(revision 106061)
@@ -4,5 +4,5 @@
 
 /*
- * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2011-2023 Oracle and/or its affiliates.
+# Copyright (C) 2011-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardGH-X11.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardGH-X11.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardGH-X11.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardGH-X11Smoke.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardGH-X11Smoke.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardGH-X11Smoke.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardHttpServer.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardHttpServer.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardHttpServer.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2023 Oracle and/or its affiliates.
+ * Copyright (C) 2023-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardQt/Makefile.kmk
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardQt/Makefile.kmk	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardQt/Makefile.kmk	(revision 106061)
@@ -5,5 +5,5 @@
 
 #
-# Copyright (C) 2011-2023 Oracle and/or its affiliates.
+# Copyright (C) 2011-2024 Oracle and/or its affiliates.
 #
 # This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardQt/tstClipboardQt.cpp
===================================================================
--- trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardQt/tstClipboardQt.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/SharedClipboard/testcase/tstClipboardQt/tstClipboardQt.cpp	(revision 106061)
@@ -5,5 +5,5 @@
 
 /*
- * Copyright (C) 2011-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2011-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/common/mime-type-converter.cpp
===================================================================
--- trunk/src/VBox/GuestHost/common/mime-type-converter.cpp	(revision 104792)
+++ trunk/src/VBox/GuestHost/common/mime-type-converter.cpp	(revision 106061)
@@ -8,5 +8,5 @@
 
 /*
- * Copyright (C) 2006-2023 Oracle and/or its affiliates.
+ * Copyright (C) 2006-2024 Oracle and/or its affiliates.
  *
  * This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libX11.def
===================================================================
--- trunk/src/VBox/GuestHost/libX11.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libX11.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libXmu.def
===================================================================
--- trunk/src/VBox/GuestHost/libXmu.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libXmu.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libXrandr.def
===================================================================
--- trunk/src/VBox/GuestHost/libXrandr.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libXrandr.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libXt.def
===================================================================
--- trunk/src/VBox/GuestHost/libXt.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libXt.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libgio-2.0.def
===================================================================
--- trunk/src/VBox/GuestHost/libgio-2.0.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libgio-2.0.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libglib-2.0.def
===================================================================
--- trunk/src/VBox/GuestHost/libglib-2.0.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libglib-2.0.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libgobject-2.0.def
===================================================================
--- trunk/src/VBox/GuestHost/libgobject-2.0.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libgobject-2.0.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libgtk-3.def
===================================================================
--- trunk/src/VBox/GuestHost/libgtk-3.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libgtk-3.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as
Index: trunk/src/VBox/GuestHost/libwayland-client.def
===================================================================
--- trunk/src/VBox/GuestHost/libwayland-client.def	(revision 104792)
+++ trunk/src/VBox/GuestHost/libwayland-client.def	(revision 106061)
@@ -5,5 +5,5 @@
 
 ;
-; Copyright (C) 2023 Oracle and/or its affiliates.
+; Copyright (C) 2023-2024 Oracle and/or its affiliates.
 ;
 ; This file is part of VirtualBox base platform packages, as