Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/ComponentName.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/ComponentName.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/ComponentName.c	(revision 106066)
@@ -3,5 +3,5 @@
   Component Name code for the virtio-net driver.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2011, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/DriverBinding.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/DriverBinding.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/DriverBinding.c	(revision 106066)
@@ -3,5 +3,5 @@
   Driver Binding code and its private helpers for the virtio-net driver.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2014, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kHwIo.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kHwIo.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kHwIo.c	(revision 106066)
@@ -3,5 +3,5 @@
   This file implements the hardware register access functions of the e1000 driver.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2021-2024, Oracle and/or its affiliates.<BR>
 
   SPDX-License-Identifier: BSD-2-Clause-Patent
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNet.h
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNet.h	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNet.h	(revision 106066)
@@ -4,5 +4,5 @@
   Protocol instances for virtio-net devices.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021-2024, Oracle and/or its affiliates.
   Copyright (c) 2017, AMD Inc, All rights reserved.
   Copyright (C) 2013, Red Hat, Inc.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNet.inf
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNet.inf	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNet.inf	(revision 106066)
@@ -5,5 +5,5 @@
 # devices.
 #
-# Copyright (C) 2021, Oracle and/or its affiliates.
+# Copyright (C) 2021-2024, Oracle and/or its affiliates.
 # Copyright (C) 2013, Red Hat, Inc.
 #
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNetHw.h
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNetHw.h	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/E1kNetHw.h	(revision 106066)
@@ -3,5 +3,5 @@
   E1000 hardware interface definitions.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2021-2024, Oracle and/or its affiliates.<BR>
 
   SPDX-License-Identifier: BSD-2-Clause-Patent
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/EntryPoint.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/EntryPoint.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/EntryPoint.c	(revision 106066)
@@ -3,5 +3,5 @@
   This file implements the entry point of the e1000 driver.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2012, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/Events.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/Events.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/Events.c	(revision 106066)
@@ -6,5 +6,5 @@
   for the e1000 driver.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2012, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpGetStatus.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpGetStatus.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpGetStatus.c	(revision 106066)
@@ -4,5 +4,5 @@
   any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2014, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpInitialize.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpInitialize.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpInitialize.c	(revision 106066)
@@ -4,5 +4,5 @@
   any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (c) 2017, AMD Inc, All rights reserved.
   Copyright (C) 2013, Red Hat, Inc.
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpMcastIpToMac.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpMcastIpToMac.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpMcastIpToMac.c	(revision 106066)
@@ -4,5 +4,5 @@
   any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.<BR>
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2010, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpReceive.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpReceive.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpReceive.c	(revision 106066)
@@ -3,5 +3,5 @@
   Implementation of the SNP.Receive() function and its private helpers if any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2013, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpReceiveFilters.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpReceiveFilters.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpReceiveFilters.c	(revision 106066)
@@ -4,5 +4,5 @@
   if any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2010, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpSharedHelpers.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpSharedHelpers.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpSharedHelpers.c	(revision 106066)
@@ -3,5 +3,5 @@
   Helper functions used by at least two Simple Network Protocol methods.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.<BR>
 
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpShutdown.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpShutdown.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpShutdown.c	(revision 106066)
@@ -3,5 +3,5 @@
   Implementation of the SNP.Shutdown() function and its private helpers if any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (c) 2017, AMD Inc, All rights reserved.
   Copyright (C) 2013, Red Hat, Inc.
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpStart.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpStart.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpStart.c	(revision 106066)
@@ -3,5 +3,5 @@
   Implementation of the SNP.Start() function and its private helpers if any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2010, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpStop.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpStop.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpStop.c	(revision 106066)
@@ -3,5 +3,5 @@
   Implementation of the SNP.Stop() function and its private helpers if any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2010, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpTransmit.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpTransmit.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpTransmit.c	(revision 106066)
@@ -3,5 +3,5 @@
   Implementation of the SNP.Transmit() function and its private helpers if any.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2013, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpUnsupported.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpUnsupported.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/E1kNetDxe/SnpUnsupported.c	(revision 106066)
@@ -5,5 +5,5 @@
   support.
 
-  Copyright (c) 2021, Oracle and/or its affiliates.
+  Copyright (c) 2021 - 2024, Oracle and/or its affiliates.
   Copyright (C) 2013, Red Hat, Inc.
   Copyright (c) 2006 - 2010, Intel Corporation. All rights reserved.<BR>
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/ComponentName.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/ComponentName.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/ComponentName.c	(revision 106066)
@@ -2,5 +2,5 @@
   Component name for the VMware SVGA 3 video controller.
 
-  Copyright (c) 2023, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2023 - 2024, Oracle and/or its affiliates.<BR>
   Copyright (c) 2006 - 2010, Intel Corporation. All rights reserved.<BR>
 
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Driver.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Driver.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Driver.c	(revision 106066)
@@ -3,5 +3,5 @@
   the VMware SVGA 3 video controller.
 
-  Copyright (c) 2023, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2023 - 2024, Oracle and/or its affiliates.<BR>
   Copyright (c) 2006 - 2019, Intel Corporation. All rights reserved.<BR>
 
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Gop.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Gop.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Gop.c	(revision 106066)
@@ -2,5 +2,5 @@
   Graphics Output Protocol functions for the VMware SVGA 3 video controller.
 
-  Copyright (c) 2023, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2023 - 2024, Oracle and/or its affiliates.<BR>
   Copyright (c) 2007 - 2018, Intel Corporation. All rights reserved.<BR>
 
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Hardware.c
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Hardware.c	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/Hardware.c	(revision 106066)
@@ -3,5 +3,5 @@
   the VMware SVGA 3 video controller.
 
-  Copyright (c) 2023, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2023 - 2024, Oracle and/or its affiliates.<BR>
 
   SPDX-License-Identifier: BSD-2-Clause-Patent
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/VmwSvga3.h
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/VmwSvga3.h	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/VmwSvga3.h	(revision 106066)
@@ -2,5 +2,5 @@
   VMware SVGA 3 Video Controller Driver
 
-  Copyright (c) 2023, Oracle and/or its affiliates.<BR>
+  Copyright (c) 2023 - 2024, Oracle and/or its affiliates.<BR>
   Copyright (c) 2006 - 2019, Intel Corporation. All rights reserved.<BR>
   SPDX-License-Identifier: BSD-2-Clause-Patent
Index: trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/VmwSvga3VideoDxe.inf
===================================================================
--- trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/VmwSvga3VideoDxe.inf	(revision 106061)
+++ trunk/src/VBox/Devices/EFI/Firmware/VBoxPkg/VmwSvga3Dxe/VmwSvga3VideoDxe.inf	(revision 106066)
@@ -3,5 +3,5 @@
 #  the VMware SVGA 3 video controller (based on QemuVideoDxe).
 #
-#  Copyright (c) 2023, Oracle and/or its affiliates.
+#  Copyright (c) 2023 - 2024, Oracle and/or its affiliates.
 #  Copyright (c) 2006 - 2019, Intel Corporation. All rights reserved.<BR>
 #