Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp	(revision 106076)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.cpp	(revision 106079)
@@ -41,4 +41,5 @@
 #include "UIHostnameDomainNameEditor.h"
 #include "UITranslationEventListener.h"
+#include "UIWizardNewVM.h"
 
 /* Other VBox includes: */
@@ -50,6 +51,8 @@
     , m_pHostnameLineEdit(0)
     , m_pDomainNameLineEdit(0)
+    , m_pProductKeyLineEdit(0)
     , m_pHostnameLabel(0)
     , m_pDomainNameLabel(0)
+    , m_pProductKeyLabel(0)
     , m_pMainLayout(0)
 {
@@ -110,20 +113,4 @@
 }
 
-int UIHostnameDomainNameEditor::firstColumnWidth() const
-{
-    int iWidth = 0;
-    if (m_pHostnameLabel)
-        iWidth = qMax(iWidth, m_pHostnameLabel->minimumSizeHint().width());
-    if (m_pDomainNameLabel)
-        iWidth = qMax(iWidth, m_pDomainNameLabel->minimumSizeHint().width());
-    return iWidth;
-}
-
-void UIHostnameDomainNameEditor::setFirstColumnWidth(int iWidth)
-{
-    if (m_pMainLayout)
-        m_pMainLayout->setColumnMinimumWidth(0, iWidth);
-}
-
 void UIHostnameDomainNameEditor::sltRetranslateUI()
 {
@@ -136,4 +123,8 @@
     if (m_pDomainNameLineEdit)
         m_pDomainNameLineEdit->setToolTip(tr("Holds the domain name."));
+    if (m_pProductKeyLabel)
+        m_pProductKeyLabel->setText(UIWizardNewVM::tr("&Product Key:"));
+    if (m_pProductKeyLineEdit)
+        m_pProductKeyLineEdit->setToolTip(UIWizardNewVM::tr("Holds the product key."));
 }
 
@@ -167,6 +158,16 @@
     setLayout(m_pMainLayout);
     int iRow = 0;
+
+
+
+    addLineEdit(iRow, m_pProductKeyLabel, m_pProductKeyLineEdit, m_pMainLayout);
     addLineEdit(iRow, m_pHostnameLabel, m_pHostnameLineEdit, m_pMainLayout);
     addLineEdit(iRow, m_pDomainNameLabel, m_pDomainNameLineEdit, m_pMainLayout);
+
+    if (m_pProductKeyLineEdit)
+    {
+        m_pProductKeyLineEdit->setInputMask(">NNNNN-NNNNN-NNNNN-NNNNN-NNNNN;#");
+        m_pProductKeyLineEdit->setMinimumWidth(fontMetrics().horizontalAdvance("NNNNN-NNNNN-NNNNN-NNNNN-NNNNN"));
+    }
 
     /* Host name and domain should be strings of minimum length of 2 and composed of alpha numerics, '-', and '.'
@@ -179,4 +180,6 @@
     connect(m_pDomainNameLineEdit, &QILineEdit::textChanged,
             this, &UIHostnameDomainNameEditor::sltDomainChanged);
+    connect(m_pProductKeyLineEdit, &QILineEdit::textChanged,
+            this, &UIHostnameDomainNameEditor::sigProductKeyChanged);
 
     sltRetranslateUI();
@@ -202,2 +205,10 @@
     emit sigHostnameDomainNameChanged(hostnameDomainName(), isComplete());
 }
+
+void UIHostnameDomainNameEditor::disableEnableProductKeyWidgets(bool fEnabled)
+{
+    if (m_pProductKeyLabel)
+        m_pProductKeyLabel->setEnabled(fEnabled);
+    if (m_pProductKeyLineEdit)
+        m_pProductKeyLineEdit->setEnabled(fEnabled);
+}
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.h	(revision 106076)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIHostnameDomainNameEditor.h	(revision 106079)
@@ -50,4 +50,5 @@
 
     void sigHostnameDomainNameChanged(const QString &strHostNameDomain, bool fIsComplete);
+    void sigProductKeyChanged(const QString &strProductKey);
 
 public:
@@ -66,6 +67,5 @@
     void mark();
 
-    int firstColumnWidth() const;
-    void setFirstColumnWidth(int iWidth);
+    void disableEnableProductKeyWidgets(bool fEnabled);
 
 private slots:
@@ -82,7 +82,9 @@
     QILineEdit *m_pHostnameLineEdit;
     QILineEdit *m_pDomainNameLineEdit;
+    QILineEdit *m_pProductKeyLineEdit;
 
     QLabel *m_pHostnameLabel;
     QLabel *m_pDomainNameLabel;
+    QLabel *m_pProductKeyLabel;
     QGridLayout *m_pMainLayout;
 };
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.cpp
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.cpp	(revision 106076)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.cpp	(revision 106079)
@@ -225,6 +225,4 @@
 UIAdditionalUnattendedOptions::UIAdditionalUnattendedOptions(QWidget *pParent /* = 0 */)
     : QGroupBox(pParent)
-    , m_pProductKeyLabel(0)
-    , m_pProductKeyLineEdit(0)
     , m_pHostnameDomainNameEditor(0)
     , m_pStartHeadlessCheckBox(0)
@@ -238,19 +236,4 @@
     m_pMainLayout->setColumnStretch(0, 0);
     m_pMainLayout->setColumnStretch(1, 1);
-    m_pProductKeyLabel = new QLabel;
-    if (m_pProductKeyLabel)
-    {
-        m_pProductKeyLabel->setAlignment(Qt::AlignRight);
-        m_pProductKeyLabel->setSizePolicy(QSizePolicy::Minimum, QSizePolicy::Fixed);
-        m_pMainLayout->addWidget(m_pProductKeyLabel, 0, 0);
-    }
-    m_pProductKeyLineEdit = new QILineEdit;
-    if (m_pProductKeyLineEdit)
-    {
-        m_pProductKeyLineEdit->setInputMask(">NNNNN-NNNNN-NNNNN-NNNNN-NNNNN;#");
-        if (m_pProductKeyLabel)
-            m_pProductKeyLabel->setBuddy(m_pProductKeyLineEdit);
-        m_pMainLayout->addWidget(m_pProductKeyLineEdit, 0, 1, 1, 2);
-    }
 
     m_pHostnameDomainNameEditor = new UIHostnameDomainNameEditor;
@@ -263,9 +246,10 @@
 
     if (m_pHostnameDomainNameEditor)
+    {
         connect(m_pHostnameDomainNameEditor, &UIHostnameDomainNameEditor::sigHostnameDomainNameChanged,
                 this, &UIAdditionalUnattendedOptions::sigHostnameDomainNameChanged);
-    if (m_pProductKeyLineEdit)
-        connect(m_pProductKeyLineEdit, &QILineEdit::textChanged,
+        connect(m_pHostnameDomainNameEditor, &UIHostnameDomainNameEditor::sigProductKeyChanged,
                 this, &UIAdditionalUnattendedOptions::sigProductKeyChanged);
+    }
     if (m_pStartHeadlessCheckBox)
         connect(m_pStartHeadlessCheckBox, &QCheckBox::toggled,
@@ -280,7 +264,4 @@
 {
     setTitle(UIWizardNewVM::tr("Additional Options"));
-
-    if (m_pProductKeyLabel)
-        m_pProductKeyLabel->setText(UIWizardNewVM::tr("&Product Key:"));
 
     if (m_pStartHeadlessCheckBox)
@@ -290,17 +271,4 @@
                                                                "unattended guest OS installation of newly created virtual machine."));
     }
-
-    int iMaxWidth = 0;
-    if (m_pProductKeyLabel)
-        iMaxWidth = qMax(m_pProductKeyLabel->minimumSizeHint().width(), iMaxWidth);
-    if (m_pHostnameDomainNameEditor)
-        iMaxWidth = qMax(m_pHostnameDomainNameEditor->firstColumnWidth(), iMaxWidth);
-    if (iMaxWidth > 0)
-    {
-        m_pMainLayout->setColumnMinimumWidth(0, iMaxWidth);
-        m_pHostnameDomainNameEditor->setFirstColumnWidth(iMaxWidth);
-    }
-    if (m_pProductKeyLineEdit)
-        m_pProductKeyLineEdit->setToolTip(UIWizardNewVM::tr("Holds the product key."));
 }
 
@@ -359,8 +327,6 @@
 void UIAdditionalUnattendedOptions::disableEnableProductKeyWidgets(bool fEnabled)
 {
-    if (m_pProductKeyLabel)
-        m_pProductKeyLabel->setEnabled(fEnabled);
-    if (m_pProductKeyLineEdit)
-        m_pProductKeyLineEdit->setEnabled(fEnabled);
+    if (m_pHostnameDomainNameEditor)
+        m_pHostnameDomainNameEditor->disableEnableProductKeyWidgets(fEnabled);
 }
 
Index: trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.h
===================================================================
--- trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.h	(revision 106076)
+++ trunk/src/VBox/Frontends/VirtualBox/src/wizards/editors/UIWizardNewVMEditors.h	(revision 106079)
@@ -124,5 +124,5 @@
 
     void sigHostnameDomainNameChanged(const QString &strHostnameDomainName, bool fIsComplete);
-    void sigProductKeyChanged(const QString &strHostnameDomainName);
+    void sigProductKeyChanged(const QString &strProductKey);
     void sigStartHeadlessChanged(bool fChecked);
 
@@ -152,6 +152,6 @@
     void prepare();
 
-    QLabel *m_pProductKeyLabel;
-    QILineEdit *m_pProductKeyLineEdit;
+
+
     UIHostnameDomainNameEditor *m_pHostnameDomainNameEditor;
     QCheckBox *m_pStartHeadlessCheckBox;